<%@ WebHandler Language="c#" Class="AvatarImageFetch" %>

using System;
using System.Web;
using System.Data;
using Npgsql;
using NpgsqlTypes;
using System.IO;

public class AvatarImageFetch : IHttpHandler
{
    const int BUFFERSIZE = 1024;

    public bool IsReusable
    {
        get
        {
            return true;
        }
    }

    //The idea behind this is to simply fetch the image out of the database and stream it down the network.
    public void ProcessRequest(HttpContext context)
    {
        HttpResponse response = context.Response;
        HttpRequest request = context.Request;
        response.ContentType = "image/jpeg";
        response.Cache.SetCacheability(HttpCacheability.Public);
        response.BufferOutput = false;
        writeSingleImage(new Guid((string)request.QueryString["MemberID"]), response.OutputStream);
        response.End();
    }

    public void writeSingleImage(Guid MemberID, Stream output)
    {
        NpgsqlConnection connection = new NpgsqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["ClubSiteDB"].ConnectionString);
        string qry = "select avatar from memberinfo where memberid=:memberid";
        NpgsqlCommand command = new NpgsqlCommand(qry, connection);

        NpgsqlParameter param0 = new NpgsqlParameter(":memberid", NpgsqlDbType.Text);
        param0.Value = MemberID.ToString ();
        command.Parameters.Add(param0);

        connection.Open();

        byte[] d = ((byte[])(command.ExecuteScalar()));
        output.Write(d, 0, d.Length);

        connection.Close();
    }
}
